#include "lcd.h"

#define __STDIO_FDEVOPEN_COMPAT_12         //old implementation of fdevopen
#include <stdio.h>
#include <stdlib.h>


void initLCD() {
	
	fdevopen (writeTextBytetoLCD, NULL, 0);
	
	DDRB|=(1<<PB3);//MOSI out
	DDRB|=(1<<PB5);//SCK out
      //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	DDRB|=(1<<PB2);//SS out

	//RESET Impulse erzeugen fr HW-Reset
	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	DDRB |=(1 << 1);
	PORTB |=(1 << 1);
	delay_ms(10);
	PORTB &=~(1 << 1);
	delay_ms(10);
	PORTB |=(1 << 1);
	delay_ms(100);

	//Initialisierung 5V (laut dog-m.pdf)
	writeInstructionBytetoLCD(0x39);

	writeInstructionBytetoLCD(0x39);

	writeInstructionBytetoLCD(0x74);

	writeInstructionBytetoLCD(0x52); 

	//BIAS for 5V=0x1c 
	//writeInstructionBytetoLCD(0x1C);

	writeInstructionBytetoLCD(0x69);

	delay_ms(250);

	writeInstructionBytetoLCD(0x0C); //(0x0F)

	delay_ms(10);


}

/*
 Diese Funktion sendet Befehle an das Display.

 */
int writeInstructionBytetoLCD(char data) {

	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	PORTB &= ~(1<<PB2); //send Instruction 0
	SPCR = (1<<SPE)|(1<<MSTR);//|(1<<SPR0);//|(1<<SPR1);
	SPDR=data;
	while (!(SPSR & (1<<SPIF))) {
	}
	SPCR=0;
	delay_us30();
	return (0);
}
/*
 Diese Funktion sendet Daten(Text) an das Display.

 */
int writeTextBytetoLCD(char data) {
	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	PORTB |= (1 <<PB2); //send Text 1
	
	//SPI einschalten
	SPCR = (1<<SPE)|(1<<MSTR);//|(1<<SPR0);//|(1<<SPR1);
	SPDR=data;
	//warten auf bertragungsende
	while (!(SPSR & (1<<SPIF))) {
	}
	//SPI ausschalten
	SPCR=0;
	delay_us30();
	return (0);
}

void clearDisplay(void) {
	writePOStoLCD(0);
	for (uint8_t i=0; i<16; i++) {
		writeTextBytetoLCD(' ');
	}
	writePOStoLCD(0b10000000);
	for (uint8_t i=0; i<16; i++) {
		writeTextBytetoLCD(' ');
	}

}

void writePOStoLCD(uint8_t pos) {


	writeInstructionBytetoLCD(0b10000000|(pos));
}

